package charactermanaj.ui;

import java.awt.Image;
import java.lang.reflect.Method;


import com.apple.eawt.Application;
import com.apple.eawt.ApplicationAdapter;
import com.apple.eawt.ApplicationEvent;

public class MainFramePartialForMacOSX {

	private MainFramePartialForMacOSX() {
		super();
	}

	public static void setupScreenMenu(final MainFrame mainFrame) {
		if (mainFrame == null) {
			throw new IllegalArgumentException();
		}
		
		Application app = Application.getApplication();
		
		app.setEnabledAboutMenu(true);
		app.setEnabledPreferencesMenu(true);

		ApplicationAdapter listener = new ApplicationAdapter() {
			public void handleAbout(ApplicationEvent arg0) {
				if (MainFrame.activedMainFrame != null) {
					MainFrame.activedMainFrame.onAbout();
				}
				arg0.setHandled(true);
			}
			public void handleQuit(ApplicationEvent arg0) {
				if (MainFrame.activedMainFrame != null) {
					MainFrame.closeAllProfiles();
				}
				arg0.setHandled(true);
			}
			public void handlePreferences(ApplicationEvent arg0) {
				if (MainFrame.activedMainFrame != null) {
					MainFrame.activedMainFrame.onPreferences();
				}
				arg0.setHandled(true);
			}
		};
		app.addApplicationListener(listener);
		
		try {
			Class<?> clz = app.getClass();
			Method mtd = clz.getMethod("setDockIconImage", new Class[] {Image.class});
			mtd.invoke(app, new Object[] {mainFrame.icon});

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
}
